<template>
  <div id="app">
    <header>
      <div class="container-fluid">
        <div class="row">
          <div class="col-sm-4"></div>
          <div class="col-sm-4 text-center mt-5">
            <router-link :to="{ name: 'Home'}"><img class="img-fluid logo" src="/static/img/logo.gif" alt="Logo"></router-link>
          </div>
          <div class="col-sm-4">
            <form class="form-inline form-search justify-content-center">
              <!-- 3. para hacer enter y cambiar de ruta -->
              <input @keyup.enter="search" v-model="query" class="form-control" type="search" placeholder="Buscar..." aria-label="Search">
              <button @click.prevent="search" class="btn btn__search my-2 my-sm-0" type="button">
                <i class="fas fa-search"></i>
              </button>
            </form>
          </div>
        </div>
        <div class="row justify-content-center margen">
          <router-link :to="{ name: 'Home'}" class="index100"><h1 class="d-inline-block">La <span class="LTP d-inline-block">LTP</span> y yo</h1></router-link>
        </div>
        <div class="row justify-content-center m">
          <span data-typedtext="Cómo sobrevivir en un mundo lleno de melocotones y no morir en el intento" class="subtitle"></span>
          <!-- <h2 class="subtitle">Cómo sobrevivir en un mundo lleno de melocotones y no morir en el intento</h2> -->
        </div>
      </div>
        <nav class="navbar navbar-expand-lg px-0 py-2">
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"><i class="fas fa-bars"></i></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav w-100 nav-pills nav-fill">
              <li class="nav-item">
                <router-link :to="{ name: 'Home'}" class="nav-link text-center bordermenu">Home</router-link>
              </li>
              <li class="nav-item">
                <router-link :to="{ name: 'Section', params: {id: 1}}" class="nav-link text-center bordermenu">Blog</router-link>
              </li>
              <li class="nav-item">
                <router-link :to="{ name: 'Sobremi'}" class="nav-link text-center bordermenu">Sobre mi</router-link>
              </li>
              <li class="nav-item">
                <router-link :to="{ name: 'Recipes', params: {id: 2}}" class="nav-link text-center bordermenu">Recetas</router-link>
              </li>
              <li class="nav-item">
                <router-link :to="{ name: 'Contact'}" class="nav-link text-center">Contacto</router-link>
              </li>
            </ul>
          </div>
        </nav>
    </header>
    <router-view/>
    <footer>
      <div class="container-fluid redes">
        <div class="row">
          <div class="col-sm-4 text-center m-auto">
            <h2 class="text-center mt-5">Sígueme en redes</h2>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-4 text-center m-auto icon-redes">
            <i class="fab fa-facebook-square mx-2"></i>
            <i class="fab fa-twitter-square mx-2"></i>
            <i class="fab fa-instagram mx-2"></i>
          </div>
        </div>
      </div>
      <div class="container-fluid pt-5 pb-5 referencias">
        <div class="row">
          <div class="col-sm-4 text-center pl-4 separacion">
            <h2>Newslettter</h2>
            <form v-if="!sendNewsletter">
              <div class="form-group">
                <label for="exampleInputEmail1">Suscribete y sé el primero en enterarte de todas las novedades en mi blog</label>
                <p :class="{ 'control': true }">
                  <input v-model="email" v-validate="'required|email'" :class="{'input': true, 'is-danger': errors.has('email') }" name="email" type="text" placeholder="Escribe tu correo electrónico..." class="form-control">
                  <p v-if="email" v-show="errors.has('email')" class="help text-danger is-danger">
                    No es un formato válido
                </p>
                <div class="form-check">
                  <input type="checkbox" class="form-check-input" id="exampleCheck1">
                  <label class="form-check-label" for="exampleCheck1">He leído y acepto la política de privacidad</label>
                </div>
              </div>
              <button @click.prevent="suscribe()" type="submit" class="btn">Enviar</button>
            </form>
            <div v-else class="alert alert-success" role="alert">
            ¡Ya estás suscrito! En breves recibirás noticias nuestras 😉
            </div>
          </div>
          <div class="col-sm-4 separacion">
            <h2 class="text-center">Categorías</h2>
            <ul>
              <router-link :to="{ name: 'Section', params: {id: 1}}" class="nav-link bordermenu category">Blog</router-link>
              <router-link :to="{ name: 'Recipes', params: {id: 2}}" class="nav-link bordermenu category">Recetas</router-link>
            </ul>
          </div>
          <div class="col-sm-4 separacion">
            <h2 class="text-center">Archivo</h2>
            <ul>
              <li><a href="#" class="category">2018</a></li>
              <li><a href="#" class="category">Marzo</a></li>
              <li class="admin"><a :href="urlLogin">
                <i class="fas fa-user"></i>
                Admin
              </a></li>
            </ul>
          </div>
        </div>
        <a href="#up" class="simplescrollup__button simplescrollup__button--hide">
          <i class="fas fa-arrow-up"></i>
        </a>
      </div>
    </footer>
  </div>
</template>

<script>
import Vue from 'vue'
import router from './router'
import '../static/js/simplescrollup.js'
export default {
  name: 'App',
  data () {
    return {
      email: '',
      sendNewsletter: false,
      router: router,
      query: '',
      urlLogin: `${process.env.URL_API}/login`,
      speed: 80
    }
  },
  mounted: function () {
    var spans = this.$el.querySelectorAll('span[data-typedtext]')
    this.playQuote(spans)
  },
  methods: {
    suscribe: function () {
      console.log(this.email)
      // Validamos el correo
      if (!this.errors.has('email') && this.email !== '') {
        Vue.http.post(`${process.env.URL_API}/api/v1/newsletter`, {
          email: this.email
        }).then(response => {
          // Response
        }, response => {
          // error callback
        })
        console.log('Todo va correctamente')
        // Enviamos el correo a la API (a la bbdd)
        this.sendNewsletter = true
        // Notificamos al usuario
      }
    },
    search: function () {
      let tempQuery = this.query
      this.query = ''
      router.push({name: 'Search', params: { text: tempQuery }})
    },
    // Typewriter
    playing: function (elements, elementIndex, textIndex) {
      if (elementIndex === elements.length) {
        return
      }
      var element = elements[elementIndex]
      if (textIndex === element.dataset.typedtext.length) {
        setTimeout(this.playing, this.speed, elements, elementIndex + 1, 0)
      } else {
        element.textContent += element.dataset.typedtext[textIndex]
        setTimeout(this.playing, this.speed, elements, elementIndex, textIndex + 1)
      }
    },
    playQuote: function (elements) {
      this.playing(elements, 0, 0)
    }
  }
}
</script>

<style>
</style>
